//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <list>
#include <algorithm>
#include <conio.h> //  getch()
#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;
std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main(int argc, char* argv[])
{
  list<int> coll;
  list<int>::iterator pos;

  //    20  40
  for (int i=20; i<=40; ++i) {
    coll.push_back(i);
  }

  //     ,  3
  // -   ,  pos  coll.end()
  pos = find (coll.begin(), coll.end(),  // 
     3);	// 

  //       
  // -   pos  coll.end().
  //     .
  reverse (pos, coll.end());

  //     25  35
  list<int>::iterator pos25,pos35;
  pos25 = find (coll.begin(), coll.end(), // 
      25); // 
  pos35 = find (coll.begin(), coll.end(), // 
      35); // 
  //     
  // -  :    pos25.
  //   pos35    .

  cout << ToRus(" = ") << *max_element (pos25, pos35) << endl;
  //     
  cout << ToRus(" = ") << *max_element (pos25, ++pos35) << endl;

  getch();
  return 0;
}
//---------------------------------------------------------------------------
